module WhyWastePerfectlyGoodGraphAlgorithmsThatAreAlreadyBuiltIntoTheRuntime (entry) where

import System.IO.Unsafe
import System.Mem
import System.Mem.Weak
import Data.IORef
import Data.Maybe
import Control.Monad

data Node = Node { children :: IORef [Node], parents :: IORef [Weak Node], idx :: Int }

mark :: [[Bool]] -> Int -> Int -> IO (Node, Node)
sweep :: [Int] -> (Node, Node) -> IO [Int]
entry :: [[Bool]] -> Int -> Int -> [Int]

mark matrix start end = do
    nodes <- sequence [Node <$> newIORef [] <*> newIORef [] <*> pure i | i <- [0..n-1]]
    forM (zip [0..] matrix) $ \(i_from, row) ->
        forM (zip [0..] row) $ \(i_to, c) ->
            when c $
                let node_from = nodes !! i_from
                    node_to   = nodes !! i_to
                in do node_from_ref <- mkWeakPtr node_from Nothing
                      modifyIORef' (children node_from) (node_to :)
                      modifyIORef' (parents node_to) (node_from_ref :)
    return (nodes !! start, nodes !! end) --         ___
    where n = length matrix --                  _____#_#_____              
--                                               | | | | | |
sweep path (start, end) --                       | | | | | |
    | idx start == idx end = return path' --     | | | | | |
    | otherwise = do --                          | | | | | |
        writeIORef (children end) [] --          | | | | | |
        performGC --                              \| | | |/
        reachable <- readIORef (parents end) --    |_|_|_|
                 >>= mapM deRefWeak
        sweep path' (start, last (catMaybes reachable))
    where path' = idx end : path

entry m start end = unsafePerformIO $ do
    mark m start end
    >>= sweep []
